diff --git a/gcc/tree-vect-loop.c b/gcc/tree-vect-loop.c
index 71c66de..9fcc7d6 100644
--- a/gcc/tree-vect-loop.c
+++ b/gcc/tree-vect-loop.c
@@ -228,7 +228,7 @@ vect_determine_vectorization_factor (loop_vec_info loop_vinfo)
 	  phi = si.phi ();
 	  stmt_info = vinfo_for_stmt (phi);
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+	    OPTINFO_VECT_REMARK
 	      << "==> examining phi: "
 	      << phi;
 
@@ -242,7 +242,7 @@ vect_determine_vectorization_factor (loop_vec_info loop_vinfo)
 
 	      if (optinfo_enabled_p ())
 		{
-		  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+		  OPTINFO_VECT_REMARK
 		    << "get vectype for scalar type:  "
 		    << slim (scalar_type);
 		}
@@ -252,7 +252,7 @@ vect_determine_vectorization_factor (loop_vec_info loop_vinfo)
 		{
 		  if (optinfo_enabled_p ())
 		    {
-		      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+		      OPTINFO_VECT_FAILURE
 			<< "not vectorized: unsupported data-type "
 			<< slim (scalar_type);
 		    }
@@ -261,14 +261,14 @@ vect_determine_vectorization_factor (loop_vec_info loop_vinfo)
 	      STMT_VINFO_VECTYPE (stmt_info) = vectype;
 
 	      if (optinfo_enabled_p ())
-		EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+		OPTINFO_VECT_REMARK
 		  << "vectype: "
 		  << slim (vectype);
 
 	      if (optinfo_enabled_p ())
 		{
 #if 0
-		  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+		  OPTINFO_VECT_REMARK
 		    << "nunits = "
 		    << TYPE_VECTOR_SUBPARTS (vectype);
 #endif
@@ -292,7 +292,7 @@ vect_determine_vectorization_factor (loop_vec_info loop_vinfo)
 
 	  if (optinfo_enabled_p ())
 	    {
-	      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+	      OPTINFO_VECT_REMARK
 		<< "==> examining statement: "
 		<< stmt;
 	    }
@@ -313,7 +313,7 @@ vect_determine_vectorization_factor (loop_vec_info loop_vinfo)
                   stmt_info = vinfo_for_stmt (pattern_stmt);
                   if (optinfo_enabled_p ())
                     {
-                      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+                      OPTINFO_VECT_REMARK
 			<< "==> examining pattern statement: "
 			<< stmt;
                     }
@@ -321,7 +321,7 @@ vect_determine_vectorization_factor (loop_vec_info loop_vinfo)
               else
 	        {
 	          if (optinfo_enabled_p ())
-	            EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+	            OPTINFO_VECT_REMARK
 		      << "skip";
                   gsi_next (&si);
 	          continue;
@@ -363,7 +363,7 @@ vect_determine_vectorization_factor (loop_vec_info loop_vinfo)
 		    {
 		      if (optinfo_enabled_p ())
 			{
-			  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+			  OPTINFO_VECT_REMARK
 			    << "==> examining pattern def stmt: "
 			    << pattern_def_stmt;
 			}
@@ -402,7 +402,7 @@ vect_determine_vectorization_factor (loop_vec_info loop_vinfo)
 		}
 	      if (optinfo_enabled_p ())
 		{
-	          EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	          OPTINFO_VECT_FAILURE
 		    << "not vectorized: irregular stmt: " << stmt;
 		}
 	      return false;
@@ -412,7 +412,7 @@ vect_determine_vectorization_factor (loop_vec_info loop_vinfo)
 	    {
 	      if (optinfo_enabled_p ())
 	        {
-	          EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	          OPTINFO_VECT_FAILURE
 		    << "not vectorized: vector stmt in loop: " << stmt;
 	        }
 	      return false;
@@ -469,7 +469,7 @@ vect_determine_vectorization_factor (loop_vec_info loop_vinfo)
 
 	      if (optinfo_enabled_p ())
 		{
-		  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+		  OPTINFO_VECT_REMARK
 		    << "get vectype for scalar type:  "
 		    << slim (scalar_type);
 		}
@@ -478,7 +478,7 @@ vect_determine_vectorization_factor (loop_vec_info loop_vinfo)
 		{
 		  if (optinfo_enabled_p ())
 		    {
-		      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+		      OPTINFO_VECT_FAILURE
 			<< "not vectorized: unsupported data-type: "
 			<< slim (scalar_type);
 		    }
@@ -490,7 +490,7 @@ vect_determine_vectorization_factor (loop_vec_info loop_vinfo)
 
 	      if (optinfo_enabled_p ())
 		{
-		  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+		  OPTINFO_VECT_REMARK
 		    << "vectype: "
 		    << slim (vectype);
 		}
@@ -510,7 +510,7 @@ vect_determine_vectorization_factor (loop_vec_info loop_vinfo)
 							     &dummy);
 	      if (optinfo_enabled_p ())
 		{
-		  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+		  OPTINFO_VECT_REMARK
 		    << "get vectype for scalar type:  "
 		    << slim (scalar_type);
 		}
@@ -520,7 +520,7 @@ vect_determine_vectorization_factor (loop_vec_info loop_vinfo)
 	    {
 	      if (optinfo_enabled_p ())
 		{
-		  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+		  OPTINFO_VECT_FAILURE
 		    << "not vectorized: unsupported data-type "
 		    << slim (scalar_type);
 		}
@@ -532,7 +532,7 @@ vect_determine_vectorization_factor (loop_vec_info loop_vinfo)
 	    {
 	      if (optinfo_enabled_p ())
 		{
-		  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+		  OPTINFO_VECT_FAILURE
 		    << ("not vectorized: different sized vector "
 			"types in statement, ")
 		    << slim (vectype)
@@ -544,14 +544,14 @@ vect_determine_vectorization_factor (loop_vec_info loop_vinfo)
 
 	  if (optinfo_enabled_p ())
 	    {
-	      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+	      OPTINFO_VECT_REMARK
 		<< "vectype: " << slim (vf_vectype);
 	    }
 
 	  if (optinfo_enabled_p ())
 	    {
 #if 0
-	      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+	      OPTINFO_VECT_REMARK
 		<< "nunits = "
 	      dump_dec (MSG_NOTE, TYPE_VECTOR_SUBPARTS (vf_vectype));
 	      dump_printf (MSG_NOTE, "\n");
@@ -572,7 +572,7 @@ vect_determine_vectorization_factor (loop_vec_info loop_vinfo)
   if (optinfo_enabled_p ())
     {
 #if 0
-      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+      OPTINFO_VECT_REMARK
 	<< "vectorization factor = "
       dump_dec (MSG_NOTE, vectorization_factor);
 #endif
@@ -581,7 +581,7 @@ vect_determine_vectorization_factor (loop_vec_info loop_vinfo)
   if (known_le (vectorization_factor, 1U))
     {
       if (optinfo_enabled_p ())
-        EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+        OPTINFO_VECT_FAILURE
 	  << "not vectorized: unsupported data-type";
       return false;
     }
@@ -604,7 +604,7 @@ vect_determine_vectorization_factor (loop_vec_info loop_vinfo)
 	  if (!mask_type)
 	    {
 	      if (optinfo_enabled_p ())
-		EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+		OPTINFO_VECT_FAILURE
 		  << "not vectorized: unsupported mask";
 	      return false;
 	    }
@@ -623,7 +623,7 @@ vect_determine_vectorization_factor (loop_vec_info loop_vinfo)
 		{
 		  if (optinfo_enabled_p ())
 		    {
-		      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+		      OPTINFO_VECT_FAILURE
 			<< ("not vectorized: can't compute mask type "
 			    "for statement, ")
 			<< stmt;
@@ -644,7 +644,7 @@ vect_determine_vectorization_factor (loop_vec_info loop_vinfo)
 		{
 		  if (optinfo_enabled_p ())
 		    {
-		      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+		      OPTINFO_VECT_FAILURE
 			<< ("not vectorized: different sized masks "
 			    "types in statement, ")
 			<< slim (mask_type)
@@ -658,7 +658,7 @@ vect_determine_vectorization_factor (loop_vec_info loop_vinfo)
 		{
 		  if (optinfo_enabled_p ())
 		    {
-		      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+		      OPTINFO_VECT_FAILURE
 			<< ("not vectorized: mixed mask and "
 			    "nonmask vector types in statement, ")
 			<< slim (mask_type)
@@ -685,7 +685,7 @@ vect_determine_vectorization_factor (loop_vec_info loop_vinfo)
 	{
 	  if (optinfo_enabled_p ())
 	    {
-	      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	      OPTINFO_VECT_FAILURE
 		<< ("not vectorized: can't compute mask type "
 		    "for statement, ")
 		<< stmt;
@@ -729,7 +729,7 @@ vect_is_simple_iv_evolution (unsigned loop_nb, tree access_fn, tree * init,
 
   if (optinfo_enabled_p ())
     {
-      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+      OPTINFO_VECT_REMARK
 	<< "step: " << slim (step_expr)
 	<< ",  init: " << slim (init_expr);
     }
@@ -748,7 +748,7 @@ vect_is_simple_iv_evolution (unsigned loop_nb, tree access_fn, tree * init,
 	  || !flag_associative_math))
     {
       if (optinfo_enabled_p ())
-        EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+        OPTINFO_VECT_FAILURE
 	  << "step unknown";
       return false;
     }
@@ -786,7 +786,7 @@ vect_analyze_scalar_cycles_1 (loop_vec_info loop_vinfo, struct loop *loop)
 
       if (optinfo_enabled_p ())
 	{
-	  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+	  OPTINFO_VECT_REMARK
 	    << "Analyze phi: " << phi;
 	}
 
@@ -804,7 +804,7 @@ vect_analyze_scalar_cycles_1 (loop_vec_info loop_vinfo, struct loop *loop)
 	  STRIP_NOPS (access_fn);
 	  if (optinfo_enabled_p ())
 	    {
-	      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+	      OPTINFO_VECT_REMARK
 		<< "Access function of PHI: " << slim (access_fn);
 	    }
 	  STMT_VINFO_LOOP_PHI_EVOLUTION_BASE_UNCHANGED (stmt_vinfo)
@@ -827,7 +827,7 @@ vect_analyze_scalar_cycles_1 (loop_vec_info loop_vinfo, struct loop *loop)
       gcc_assert (STMT_VINFO_LOOP_PHI_EVOLUTION_PART (stmt_vinfo) != NULL_TREE);
 
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+	OPTINFO_VECT_REMARK
 	  << "Detected induction";
       STMT_VINFO_DEF_TYPE (stmt_vinfo) = vect_induction_def;
     }
@@ -843,7 +843,7 @@ vect_analyze_scalar_cycles_1 (loop_vec_info loop_vinfo, struct loop *loop)
 
       if (optinfo_enabled_p ())
         {
-          EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+          OPTINFO_VECT_REMARK
 	    << "Analyze phi: " << phi;
         }
 
@@ -857,7 +857,7 @@ vect_analyze_scalar_cycles_1 (loop_vec_info loop_vinfo, struct loop *loop)
           if (double_reduc)
             {
               if (optinfo_enabled_p ())
-                EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+                OPTINFO_VECT_REMARK
 		  << "Detected double reduction";
 
               STMT_VINFO_DEF_TYPE (stmt_vinfo) = vect_double_reduction_def;
@@ -869,7 +869,7 @@ vect_analyze_scalar_cycles_1 (loop_vec_info loop_vinfo, struct loop *loop)
               if (loop != LOOP_VINFO_LOOP (loop_vinfo))
                 {
                   if (optinfo_enabled_p ())
-                    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+                    OPTINFO_VECT_REMARK
 		      << "Detected vectorizable nested cycle";
 
                   STMT_VINFO_DEF_TYPE (stmt_vinfo) = vect_nested_cycle;
@@ -879,7 +879,7 @@ vect_analyze_scalar_cycles_1 (loop_vec_info loop_vinfo, struct loop *loop)
               else
                 {
                   if (optinfo_enabled_p ())
-                    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+                    OPTINFO_VECT_REMARK
 		      << "Detected reduction";
 
                   STMT_VINFO_DEF_TYPE (stmt_vinfo) = vect_reduction_def;
@@ -895,7 +895,7 @@ vect_analyze_scalar_cycles_1 (loop_vec_info loop_vinfo, struct loop *loop)
         }
       else
         if (optinfo_enabled_p ())
-          EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+          OPTINFO_VECT_FAILURE
 	    << "Unknown def-use cycle pattern";
     }
 }
@@ -1479,7 +1479,7 @@ vect_analyze_loop_form_1 (struct loop *loop, gcond **loop_cond,
       if (loop->num_nodes != 2)
         {
           if (optinfo_enabled_p ())
-            EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+            OPTINFO_VECT_FAILURE
 	      << "not vectorized: control flow in loop";
           return false;
         }
@@ -1487,7 +1487,7 @@ vect_analyze_loop_form_1 (struct loop *loop, gcond **loop_cond,
       if (empty_block_p (loop->header))
 	{
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	    OPTINFO_VECT_FAILURE
 	      << "not vectorized: empty loop";
 	  return false;
 	}
@@ -1517,7 +1517,7 @@ vect_analyze_loop_form_1 (struct loop *loop, gcond **loop_cond,
       if ((loop->inner)->inner || (loop->inner)->next)
 	{
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	    OPTINFO_VECT_FAILURE
 	      << "not vectorized: multiple nested loops";
 	  return false;
 	}
@@ -1525,7 +1525,7 @@ vect_analyze_loop_form_1 (struct loop *loop, gcond **loop_cond,
       if (loop->num_nodes != 5)
         {
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	    OPTINFO_VECT_FAILURE
 	      << "not vectorized: control flow in loop";
 	  return false;
         }
@@ -1536,7 +1536,7 @@ vect_analyze_loop_form_1 (struct loop *loop, gcond **loop_cond,
 	  || single_exit (innerloop)->dest != EDGE_PRED (loop->latch, 0)->src)
 	{
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	    OPTINFO_VECT_FAILURE
 	      << "not vectorized: unsupported outerloop form";
 	  return false;
 	}
@@ -1551,7 +1551,7 @@ vect_analyze_loop_form_1 (struct loop *loop, gcond **loop_cond,
 	  || !integer_onep (inner_assumptions))
 	{
 	  if (optinfo_enabled_p ())
-            EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+            OPTINFO_VECT_FAILURE
 	      << "not vectorized: bad inner loop";
 	  return false;
 	}
@@ -1559,13 +1559,13 @@ vect_analyze_loop_form_1 (struct loop *loop, gcond **loop_cond,
       if (!expr_invariant_in_loop_p (loop, inner_niter))
 	{
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	    OPTINFO_VECT_FAILURE
 	      << "not vectorized: inner-loop count not invariant";
 	  return false;
 	}
 
       if (optinfo_enabled_p ())
-        EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+        OPTINFO_VECT_REMARK
 	  << "Considering outer-loop vectorization";
     }
 
@@ -1575,10 +1575,10 @@ vect_analyze_loop_form_1 (struct loop *loop, gcond **loop_cond,
       if (optinfo_enabled_p ())
         {
           if (!single_exit (loop))
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	    OPTINFO_VECT_FAILURE
 	      << "not vectorized: multiple exits";
           else if (EDGE_COUNT (loop->header->preds) != 2)
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	    OPTINFO_VECT_FAILURE
 	      << "not vectorized: too many incoming edges";
         }
       return false;
@@ -1592,7 +1592,7 @@ vect_analyze_loop_form_1 (struct loop *loop, gcond **loop_cond,
       || !gimple_seq_empty_p (phi_nodes (loop->latch)))
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	OPTINFO_VECT_FAILURE
 	  << "not vectorized: latch block not empty";
       return false;
     }
@@ -1602,7 +1602,7 @@ vect_analyze_loop_form_1 (struct loop *loop, gcond **loop_cond,
   if (e->flags & EDGE_ABNORMAL)
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	OPTINFO_VECT_FAILURE
 	  << "not vectorized: abnormal loop exit edge";
       return false;
     }
@@ -1612,7 +1612,7 @@ vect_analyze_loop_form_1 (struct loop *loop, gcond **loop_cond,
   if (!*loop_cond)
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	OPTINFO_VECT_FAILURE
 	  << "not vectorized: complicated exit condition";
       return false;
     }
@@ -1622,7 +1622,7 @@ vect_analyze_loop_form_1 (struct loop *loop, gcond **loop_cond,
       || chrec_contains_undetermined (*number_of_iterations))
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	OPTINFO_VECT_FAILURE
 	  << "not vectorized: number of iterations cannot be computed";
       return false;
     }
@@ -1630,7 +1630,7 @@ vect_analyze_loop_form_1 (struct loop *loop, gcond **loop_cond,
   if (integer_zerop (*number_of_iterations))
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	OPTINFO_VECT_FAILURE
 	  << "not vectorized: number of iterations = 0";
       return false;
     }
@@ -1671,7 +1671,7 @@ vect_analyze_loop_form (struct loop *loop)
 
   if (!LOOP_VINFO_NITERS_KNOWN_P (loop_vinfo))
     if (optinfo_enabled_p ())
-      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+      OPTINFO_VECT_REMARK
 	<< "symbolic number of iterations is "
 	<< details (number_of_iterations);
 
@@ -1734,13 +1734,13 @@ vect_update_vf_for_slp (loop_vec_info loop_vinfo)
 
   if (only_slp_in_loop)
     {
-      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+      OPTINFO_VECT_REMARK
 	<< "Loop contains only SLP stmts";
       vectorization_factor = LOOP_VINFO_SLP_UNROLLING_FACTOR (loop_vinfo);
     }
   else
     {
-      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+      OPTINFO_VECT_REMARK
 	<< "Loop contains SLP and non-SLP stmts";
       /* Both the vectorization factor and unroll factor have the form
 	 current_vector_size * X for some rational X, so they must have
@@ -1754,7 +1754,7 @@ vect_update_vf_for_slp (loop_vec_info loop_vinfo)
   if (optinfo_enabled_p ())
     {
 #if 0
-      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+      OPTINFO_VECT_REMARK
 	<< "Updating vectorization factor to ");
       dump_dec (MSG_NOTE, vectorization_factor);
 #endif
@@ -1819,7 +1819,7 @@ vect_analyze_loop_operations (loop_vec_info loop_vinfo)
           stmt_info = vinfo_for_stmt (phi);
           if (optinfo_enabled_p ())
             {
-              EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+              OPTINFO_VECT_REMARK
 		<< "examining phi: "
 		<< phi;
             }
@@ -1838,7 +1838,7 @@ vect_analyze_loop_operations (loop_vec_info loop_vinfo)
 		  && !vect_active_double_reduction_p (stmt_info))
                 {
                   if (optinfo_enabled_p ())
-		    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+		    OPTINFO_VECT_FAILURE
 		      << "Unsupported loop-closed phi in outer-loop";
                   return false;
                 }
@@ -1881,7 +1881,7 @@ vect_analyze_loop_operations (loop_vec_info loop_vinfo)
             {
               /* A scalar-dependence cycle that we don't support.  */
               if (optinfo_enabled_p ())
-		EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+		OPTINFO_VECT_FAILURE
 		  << "not vectorized: scalar dependence cycle";
               return false;
             }
@@ -1908,7 +1908,7 @@ vect_analyze_loop_operations (loop_vec_info loop_vinfo)
             {
               if (optinfo_enabled_p ())
                 {
-		  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+		  OPTINFO_VECT_FAILURE
 		    << "not vectorized: relevant phi not supported: "
 		    << phi;
                 }
@@ -1934,10 +1934,10 @@ vect_analyze_loop_operations (loop_vec_info loop_vinfo)
   if (!need_to_vectorize)
     {
       if (optinfo_enabled_p ())
-        EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+        OPTINFO_VECT_REMARK
 	  << "All the computation can be taken out of the loop";
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	OPTINFO_VECT_FAILURE
 	  << "not vectorized: redundant loop. no profit to vectorize";
       return false;
     }
@@ -1970,7 +1970,7 @@ vect_analyze_loop_costing (loop_vec_info loop_vinfo)
 	  && (unsigned HOST_WIDE_INT) max_niter < assumed_vf)
 	{
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	    OPTINFO_VECT_FAILURE
 	      << ("not vectorized: iteration count smaller than "
 		  "vectorization factor");
 	  return 0;
@@ -1984,10 +1984,10 @@ vect_analyze_loop_costing (loop_vec_info loop_vinfo)
   if (min_profitable_iters < 0)
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	OPTINFO_VECT_FAILURE
 	  << "not vectorized: vectorization not profitable";
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	OPTINFO_VECT_FAILURE
 	  << "not vectorized: vector version will never be profitable";
       return -1;
     }
@@ -2006,10 +2006,10 @@ vect_analyze_loop_costing (loop_vec_info loop_vinfo)
       && LOOP_VINFO_INT_NITERS (loop_vinfo) < th)
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	OPTINFO_VECT_FAILURE
 	  << "not vectorized: vectorization not profitable";
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+	OPTINFO_VECT_REMARK
 	  << ("not vectorized: iteration count smaller than user "
 	      "specified loop bound parameter or minimum profitable "
 	      "iterations (whichever is more conservative)");
@@ -2024,10 +2024,10 @@ vect_analyze_loop_costing (loop_vec_info loop_vinfo)
 	  < MAX (th, (unsigned) min_profitable_estimate)))
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	OPTINFO_VECT_FAILURE
 	  << "not vectorized: estimated iteration count too small";
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+	OPTINFO_VECT_REMARK
 	  << ("not vectorized: estimated iteration count smaller "
 	      "than specified loop bound parameter or minimum "
 	      "profitable iterations (whichever is more "
@@ -2065,7 +2065,7 @@ vect_analyze_loop_2 (loop_vec_info loop_vinfo, bool &fatal)
   if (!find_loop_nest (loop, &LOOP_VINFO_LOOP_NEST (loop_vinfo)))
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	OPTINFO_VECT_FAILURE
 	  << ("not vectorized: loop nest containing two "
 	      "or more consecutive inner loops cannot be "
 	      "vectorized");
@@ -2114,7 +2114,7 @@ vect_analyze_loop_2 (loop_vec_info loop_vinfo, bool &fatal)
 		  }
 	      }
 	    if (optinfo_enabled_p ())
-	      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	      OPTINFO_VECT_FAILURE
 		<< ("not vectorized: loop contains function "
 		    "calls or data references that cannot "
 		    "be analyzed");
@@ -2129,7 +2129,7 @@ vect_analyze_loop_2 (loop_vec_info loop_vinfo, bool &fatal)
   if (!ok)
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	OPTINFO_VECT_FAILURE
 	  << "bad data references";
       return false;
     }
@@ -2149,7 +2149,7 @@ vect_analyze_loop_2 (loop_vec_info loop_vinfo, bool &fatal)
   if (!ok)
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	OPTINFO_VECT_FAILURE
 	  << "bad data access";
       return false;
     }
@@ -2160,7 +2160,7 @@ vect_analyze_loop_2 (loop_vec_info loop_vinfo, bool &fatal)
   if (!ok)
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	OPTINFO_VECT_FAILURE
 	  << "unexpected pattern";
       return false;
     }
@@ -2179,7 +2179,7 @@ vect_analyze_loop_2 (loop_vec_info loop_vinfo, bool &fatal)
 	  && maybe_lt (max_vf, min_vf)))
     {
       if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	    OPTINFO_VECT_FAILURE
 	      << "bad data dependence";
       return false;
     }
@@ -2189,7 +2189,7 @@ vect_analyze_loop_2 (loop_vec_info loop_vinfo, bool &fatal)
   if (!ok)
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	OPTINFO_VECT_FAILURE
 	  << "can't determine vectorization factor";
       return false;
     }
@@ -2197,7 +2197,7 @@ vect_analyze_loop_2 (loop_vec_info loop_vinfo, bool &fatal)
       && maybe_lt (max_vf, LOOP_VINFO_VECT_FACTOR (loop_vinfo)))
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	OPTINFO_VECT_FAILURE
 	  << "bad data dependence";
       return false;
     }
@@ -2240,7 +2240,7 @@ start_over:
   if (LOOP_VINFO_NITERS_KNOWN_P (loop_vinfo) && optinfo_enabled_p ())
     {
 #if 0
-      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+      OPTINFO_VECT_REMARK
 	<< "vectorization_factor = "
       dump_dec (MSG_NOTE, vectorization_factor);
       dump_printf (MSG_NOTE, ", niters = " HOST_WIDE_INT_PRINT_DEC "\n",
@@ -2258,7 +2258,7 @@ start_over:
   if (!ok)
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	OPTINFO_VECT_FAILURE
 	  << "bad data alignment";
       return false;
     }
@@ -2280,7 +2280,7 @@ start_over:
     if (!ok)
       {
 	if (optinfo_enabled_p ())
-	  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	  OPTINFO_VECT_FAILURE
 	    << "bad data alignment";
         return false;
       }
@@ -2303,7 +2303,7 @@ start_over:
   if (!ok)
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	OPTINFO_VECT_FAILURE
 	  << "bad operation or unsupported loop bound";
       return false;
     }
@@ -2316,10 +2316,10 @@ start_over:
   if (optinfo_enabled_p ())
     {
       if (LOOP_VINFO_FULLY_MASKED_P (loop_vinfo))
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+	OPTINFO_VECT_REMARK
 	  << "using a fully-masked loop";
       else
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+	OPTINFO_VECT_REMARK
 	  << "not using a fully-masked loop";
     }
 
@@ -2336,7 +2336,7 @@ start_over:
       if (known_lt (wi::to_widest (scalar_niters), vf))
 	{
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+	    OPTINFO_VECT_REMARK
 	      << ("loop has not enough iterations to support"
 		  " peeling for gaps");
 	  return false;
@@ -2350,7 +2350,7 @@ start_over:
   if (!res)
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	OPTINFO_VECT_FAILURE
 	  << "Loop costings not worthwhile";
       return false;
     }
@@ -2388,7 +2388,7 @@ start_over:
       || LOOP_VINFO_PEELING_FOR_NITER (loop_vinfo))
     {
       if (optinfo_enabled_p ())
-        EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+        OPTINFO_VECT_REMARK
 	  << "epilog loop required";
       if (!vect_can_advance_ivs_p (loop_vinfo)
 	  || !slpeel_can_duplicate_loop_p (LOOP_VINFO_LOOP (loop_vinfo),
@@ -2396,7 +2396,7 @@ start_over:
 							 (loop_vinfo))))
         {
           if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	    OPTINFO_VECT_FAILURE
 	      << "not vectorized: can't create required epilog loop";
           goto again;
         }
@@ -2483,7 +2483,7 @@ again:
     }
 
   if (optinfo_enabled_p ())
-    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+    OPTINFO_VECT_REMARK
       << "re-trying with SLP disabled";
 
   /* Roll back state appropriately.  No SLP this time.  */
@@ -2567,7 +2567,7 @@ vect_analyze_loop (struct loop *loop, loop_vec_info orig_loop_vinfo)
       && LOOP_VINFO_VECTORIZABLE_P (loop_vec_info_for_loop (loop_outer (loop))))
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+	OPTINFO_VECT_REMARK
 	  << "outer-loop already vectorized";
       return NULL;
     }
@@ -2580,7 +2580,7 @@ vect_analyze_loop (struct loop *loop, loop_vec_info orig_loop_vinfo)
       if (!loop_vinfo)
 	{
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	    OPTINFO_VECT_FAILURE
 	      << "bad loop form";
 	  return NULL;
 	}
@@ -2616,7 +2616,7 @@ vect_analyze_loop (struct loop *loop, loop_vec_info orig_loop_vinfo)
       if (optinfo_enabled_p ())
 	{
 #if 0
-	  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+	  OPTINFO_VECT_REMARK
 	    << "***** Re-trying analysis with vector size ";
 	  dump_dec (MSG_NOTE, current_vector_size);
 	  dump_printf (MSG_NOTE, "\n");
@@ -2919,7 +2919,7 @@ vect_is_slp_reduction (loop_vec_info loop_info, gimple *phi,
   	    {
 	      if (optinfo_enabled_p ())
 		{
-		  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+		  OPTINFO_VECT_REMARK
 		    << "swapping oprnds: " << next_stmt;
 		}
 
@@ -3174,7 +3174,7 @@ vect_is_simple_reduction (loop_vec_info loop_info, gimple *phi,
       if (!flow_bb_inside_loop_p (loop, gimple_bb (use_stmt)))
         {
           if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	    OPTINFO_VECT_FAILURE
 	      << "intermediate value used outside loop";
 
           return NULL;
@@ -3184,7 +3184,7 @@ vect_is_simple_reduction (loop_vec_info loop_info, gimple *phi,
       if (nloop_uses > 1)
         {
           if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	    OPTINFO_VECT_FAILURE
 	      << "reduction value used in loop";
           return NULL;
         }
@@ -3197,7 +3197,7 @@ vect_is_simple_reduction (loop_vec_info loop_info, gimple *phi,
   if (TREE_CODE (loop_arg) != SSA_NAME)
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	OPTINFO_VECT_FAILURE
 	  << "reduction: not ssa_name: "
 	  << slim (loop_arg);
       return NULL;
@@ -3218,7 +3218,7 @@ vect_is_simple_reduction (loop_vec_info loop_info, gimple *phi,
     {
       if (optinfo_enabled_p ())
 	{
-	  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	  OPTINFO_VECT_FAILURE
 	    << "reduction: unhandled reduction operation: "
 	    << def_stmt;
 	}
@@ -3243,7 +3243,7 @@ vect_is_simple_reduction (loop_vec_info loop_info, gimple *phi,
       if (nloop_uses > 1)
 	{
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	    OPTINFO_VECT_FAILURE
 	      << "reduction used in loop";
 	  return NULL;
 	}
@@ -3259,7 +3259,7 @@ vect_is_simple_reduction (loop_vec_info loop_info, gimple *phi,
           || TREE_CODE (op1) != SSA_NAME)
         {
           if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	    OPTINFO_VECT_FAILURE
 	      << "unsupported phi node definition";
 
           return NULL;
@@ -3379,7 +3379,7 @@ vect_is_simple_reduction (loop_vec_info loop_info, gimple *phi,
       if (optinfo_enabled_p ())
         {
 	  pending_optinfo info
-	    = EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+	    = OPTINFO_VECT_REMARK
 	        << "reduction: multiple types: operation type: "
 		<< slim (type)
 		<< ", operands types: "
@@ -3594,7 +3594,7 @@ vect_get_known_peeling_cost (loop_vec_info loop_vinfo, int peel_iters_prologue,
     {
       *peel_iters_epilogue = assumed_vf / 2;
       if (optinfo_enabled_p ())
-        EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+        OPTINFO_VECT_REMARK
 	  << ("cost model: epilogue peel iters set to vf/2 "
 	      "because loop iterations are unknown");
 
@@ -3679,7 +3679,7 @@ vect_estimate_min_profitable_iters (loop_vec_info loop_vinfo,
   /* Cost model disabled.  */
   if (unlimited_cost_model (LOOP_VINFO_LOOP (loop_vinfo)))
     {
-      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+      OPTINFO_VECT_REMARK
 	<< "cost model disabled";
       *ret_min_profitable_niters = 0;
       *ret_min_profitable_estimate = 0;
@@ -3944,7 +3944,7 @@ vect_estimate_min_profitable_iters (loop_vec_info loop_vinfo,
     {
       /* FIXME: do we want to do something special for such a table of
 	 data?  */
-      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+      OPTINFO_VECT_REMARK
 	<< "Cost model analysis:\n"
 	<< optinfo_printf ("  Vector inside of loop cost: %d\n",
 			   vec_inside_cost)
@@ -4002,7 +4002,7 @@ vect_estimate_min_profitable_iters (loop_vec_info loop_vinfo,
 		    "did not happen for a simd loop");
 
       if (optinfo_enabled_p ())
-        EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+        OPTINFO_VECT_FAILURE
 	  << optinfo_printf ("cost model: the vector iteration cost = %d "
 			     "divided by the scalar iteration cost = %d "
 			     "is greater or equal to the vectorization factor = %d",
@@ -4022,7 +4022,7 @@ vect_estimate_min_profitable_iters (loop_vec_info loop_vinfo,
     min_profitable_iters = assumed_vf + peel_iters_prologue;
 
   if (optinfo_enabled_p ())
-    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+    OPTINFO_VECT_REMARK
       << optinfo_printf ("  Runtime profitability threshold = %d",
 			 min_profitable_iters);
 
